{
  A simple User-Interface for TPYacc under M$-Windows


  Copyright (C) 1998     Robert Zierer <rz1@stud.mw.tu-muenchen.de>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

$Revision: 1.2 $
$Date: 1999/05/02 13:02:22 $

}

unit Yaccdlg32;

(* 4-22-98 RZ *)

interface

uses WinTypes, WinProcs, SysUtils, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Dialogs, Spin;

type
  TBtnBottomDlg = class(TForm)
    OKBtn: TBitBtn;
    HelpBtn: TBitBtn;
    OutputMemo: TMemo;
    OpenDialog1: TOpenDialog;
    Bevel2: TBevel;
    CheckBoxVerbose: TCheckBox;
    CheckBoxDebug: TCheckBox;
    LabelFile: TLabel;
    Bevel3: TBevel;
    CheckBoxBatchMode: TCheckBox;
    CheckBoxHTML: TCheckBox;
    GroupBoxStackType: TGroupBox;
    GroupBoxTableType: TGroupBox;
    RadioButtonNormalTable: TRadioButton;
    RadioButtonExternTable: TRadioButton;
    RadioButtonResourceTable: TRadioButton;
    RadioButtonStaticStack: TRadioButton;
    RadioButtonDynamicStack: TRadioButton;
    LabelPrefix: TLabel;
    EditPrefix: TEdit;
    CheckBoxCodFile: TCheckBox;
    EditCodFileName: TEdit;
    BitBtnCodeFile: TBitBtn;
    EditFilename: TEdit;
    BitBtnFile: TBitBtn;
    CancelBtn: TSpeedButton;
    GroupBoxRulestrings: TGroupBox;
    CheckBoxRuleStrings: TCheckBox;
    EditRuleStrFilename: TEdit;
    BitBtnRuleStrFile: TBitBtn;
    RadioButtonRulestringParser: TRadioButton;
    RadioButtonRulestringRC: TRadioButton;
    RadioButtonRulestringTextfile: TRadioButton;
    SpinEditRulestringRCBaseCount: TSpinEdit;
    procedure FileBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CheckBoxVerboseClick(Sender: TObject);
    procedure CheckBoxDebugClick(Sender: TObject);
    procedure RadioButtonNormalTableClick(Sender: TObject);
    procedure RadioButtonExternTableClick(Sender: TObject);
    procedure RadioButtonResourceTableClick(Sender: TObject);
    procedure EditPrefixChange(Sender: TObject);
    procedure CheckBoxBatchModeClick(Sender: TObject);
    procedure CheckBoxHTMLClick(Sender: TObject);
    procedure RadioButtonStaticStackClick(Sender: TObject);
    procedure RadioButtonDynamicStackClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure CheckBoxCodFileClick(Sender: TObject);
    procedure BitBtnCodeFileClick(Sender: TObject);
    procedure EditFilenameChange(Sender: TObject);
    procedure EditCodFileNameChange(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CheckBoxRuleStringsClick(Sender: TObject);
    procedure EditRuleStrFilenameChange(Sender: TObject);
    procedure BitBtnRuleStrFileClick(Sender: TObject);
    procedure RadioButtonRulestringRCClick(Sender: TObject);
    procedure SpinEditRulestringRCBaseCountChange(Sender: TObject);
    procedure RadioButtonRulestringTextfileClick(Sender: TObject);
    procedure RadioButtonRulestringParserClick(Sender: TObject);
  private
    { Private declarations }
    procedure OnExcept(Sender: TObject; E: Exception);
    procedure GetFileNames;
    procedure SearchCodFileName;
  public
    { Public declarations }
    procedure Execute(Sender: TObject);
  end;

var
  BtnBottomDlg: TBtnBottomDlg;

type
  TOutputMedium = ( omFile, omBoth, omScreen );

type
  EYaccException = class(Exception);

procedure GiveOutString( Medium: TOutputMedium; s : string );
  (* gives out a string in the current line*)
procedure GiveOutChar( Medium: TOutputMedium; c : Char );
  (* gives out a char in the current line*)
procedure GiveOutLine( Medium: TOutputMedium; s : string );
  (* gives out a string in a new line; reuses empty lines*)

procedure RenameIfExists( old : string );

implementation
uses
{$ifdef VER80}
     WinDos,
{$else} {$ifdef WIN32}
{$endif} {$endif}
     Yacc, YaccBase, YaccMsgs, YaccParseTable, YaccTables
     {$ifdef LargeObjTables}, YaccTypes{$endif}
     ;

{$R YaccDlg3.DFM}

procedure RenameIfExists( old : string );
var new : string;
begin
  if FileExists( old ) then
    begin
    new := concat( root( old ), '.~'+copy( ExtractFileExt( old ), 2, 2 ) );
    if FileExists( new ) then
      DeleteFile( new );
    RenameFile( old, new );
    end
end;

procedure GiveOutString( Medium: TOutputMedium; s : string );
begin
  case Medium of
    omFile :
      begin {$I-}
      Writeln( yyLst, s );
      end; {$I+}
    omBoth :
      begin
      with BtnBottomDlg.OutputMemo.Lines do
        begin
        Strings[ Count-1 ] := Strings[ Count-1 ] + s;
        end;
      {$I-}
      Writeln( yyLst, s );
      {$I+}
      end;
    omScreen :
      begin
      with BtnBottomDlg.OutputMemo.Lines do
        begin
        Strings[ Count-1 ] := Strings[ Count-1 ] + s;
        end;
      end;
    else
  end;
end;

procedure GiveOutChar( Medium: TOutputMedium; c : Char );
begin
  case Medium of
    omFile :
      begin {$I-}
      Writeln( yyLst, c );
      end;{$I+}
    omBoth :
      begin
      with BtnBottomDlg.OutputMemo.Lines do
        begin
        Strings[ Count-1 ] := Strings[ Count-1 ] + c;
        end;
      {$I-}
      Writeln( yyLst, c );
      {$I+}
      end;
    omScreen :
      begin
      with BtnBottomDlg.OutputMemo.Lines do
        begin
        Strings[ Count-1 ] := Strings[ Count-1 ] + c;
        end;
      end;
    else
  end;
end;

procedure GiveOutLine( Medium: TOutputMedium; s : string );
begin
  case Medium of
    omFile :
      begin{$I-}
      if GenHtml then
        write( yyLst, '<BR>' );
      Writeln( yyLst, s );
      end;{$I+}
    omBoth :
      begin
      with BtnBottomDlg.OutputMemo.Lines do
        begin
        if Count < 1 then
          Add( s )
        else
          if Strings[ Count-1 ] = '' then
            Strings[ Count-1 ] := s
          else
            Add( s );
        end;
      {$I-}
      if GenHtml then
        write( yyLst, '<BR>' );
      Writeln( yyLst, s );{$I+}
      end;
    omScreen :
      begin
      with BtnBottomDlg.OutputMemo.Lines do
        begin
        if Count < 1 then
          Add( s )
        else
          if Strings[ Count-1 ] = '' then
            Strings[ Count-1 ] := s
          else
            Add( s );
        end;
      end;
    else
  end;
end;

{******************************************************************************************}

procedure TBtnBottomDlg.GetFileNames;
begin
  with OpenDialog1 do
    begin
    Filter := 'Yacc files (*.Y)|*.Y|All files|*.*';
    if Execute then
      begin
      yfilename := FileName;
      OKBtn.Enabled := true;
      EditFileName.Text := yfilename;
      if ( pasfilename = '' ) {not supplied} or
         ( ( root(yfilename) = root(pasfilename) ) and
           ( UpperCase(ExtractFileExt(pasfilename)) = 'PAS' ) ) {default name}
         then
        pasfilename := ChangeFileExt(yfilename, '.PAS');
      if not GenHtml then
        lstfilename := ChangeFileExt( yfilename, '.LST' )
      else
        lstfilename := ChangeFileExt( yfilename, '.HTM' );
      ActiveControl := OKBtn;
      end
    else
      begin
      ActiveControl := EditFilename;
      OKBtn.Enabled := false;
      EditFileName.Text := yfilename;
      end;
    end;
end;

procedure TBtnBottomDlg.SearchCodFileName;
var
{$ifdef VER80}
    Dir : PChar;
{$endif}
    DirStr : string;
begin
  if ( codfilename = '' ) then
    fatal( no_filename + ' for codfile' );
  (* search code template in directory of yfilename, then on current directory,
     then on path where Yacc is : *)
  {codfilename could contain path !! }
  if ( pos( '\', codfilename ) = 0 ) and ( pos( ':', codfilename ) = 0 ) then
    begin {no path specified}
    if FileExists( ExtractFilePath( yfilename ) + codfilename ) then
      begin {search where yfilename is}
      codfilename := ExtractFilePath( yfilename ) + codfilename;
      end
    else
      begin {search act. Dir,Drive}
{$ifdef VER80}
      try
        GetMem( Dir, 250 );
        GetCurDir( Dir, 0 );
      finally
        FreeMem( Dir, 250 );
      end;
      DirStr := StrPas( Dir );
{$else} {$ifdef WIN32}
      DirStr := GetCurrentDir;
{$endif} {$endif}
      if FileExists( DirStr + codfilename ) then
        codfilename := DirStr + codfilename
      else if FileExists( ExtractFilePath( Application.ExeName ) + codfilename ) then
        begin {search where DYacc.exe is}
        codfilename := ExtractFilePath( Application.ExeName ) + codfilename;
        end
      else if FileExists( ExtractFilePath( ParamStr(0) ) + codfilename ) then
        begin {search where DYacc.exe is}
        codfilename := ExtractFilePath( ParamStr(0) ) + codfilename;
        end
      else {not found}
        fatal( cannot_open_file + ' : ' + codfilename );
      end
    end
  else
    begin {path specified}
    if FileExists( codfilename ) then
    else {not found}
      fatal(file_not_exist + ' : ' + codfilename );
    end;
  EditCodFileName.Text := codfilename;
end;

const CODFILENAMEDEFAULT = 'yyparse.cod';

procedure TBtnBottomDlg.Execute(Sender: TObject);
var i : integer;

  function GetIntStr( s: string; var Count: word; var fn: string ): boolean;
  var
    i: byte;
  begin
    if s = '' then
      begin
      Result := false;
      Exit;
      end;
    i := pos( ',', s );
    if i = 1 then {Count not set}
      Count := Count
    else
      begin
      Count := StrToInt( copy( s, 1, i - 1 ) );
      end;
    if i = length( s ) then {fn not set}
      fn := ''
    else
      fn := copy( s, i + 1, 255 );
    Result := true;
  end;

  procedure InvalidOptionError;
  begin
    error( invalid_option + ' in param #' + IntToStr(i) + ':' + paramStr(i) );
  end;

var parStr : string;
begin
   verbose := false;
   CheckBoxVerbose.Checked := false;

   debug := false;
   CheckBoxDebug.Checked := false;

   BatchMode := false;
   CheckBoxBatchMode.Checked := false;

   RuleStrings := false;
   RuleStrFilename := '';
   RuleStrBaseCount := 0;
   EditRuleStrFilename.Text := '';
   CheckBoxRuleStrings.Checked := false;
   RadioButtonRulestringParser.Enabled := false;
   RadioButtonRulestringRC.Enabled := false;
   RadioButtonRulestringTextfile.Enabled := false;

   GenHtml := false;
   CheckBoxHTML.Checked := false;

   ResTablePrefix := '';
   EditPrefix.Text := '';

   TableType := ttNormal;
   RadioButtonNormalTable.Checked := true;
   StackType := stStatic;
   RadioButtonStaticStack.Checked := true;

   ActiveControl := EditFileName;
   BtnBottomDlg.OKBtn.Enabled := false;

   codfilename := CODFILENAMEDEFAULT;
   EditCodFileName.Text := codfilename;

   yfilename := '';
   EditFilename.Text := '';

  (* sign-on: *)
  write_sign_on;

  (* parse command line: *)

  if paramCount=0 then
    begin
    write_usage;
    write_defaults;
    exit;            {if no params are provided; ask for it in the dialog}
    end;

  yfilename := '';
  pasfilename := '';

  for i := 1 to paramCount do
    if copy(paramStr(i), 1, 1)='/' then
      begin
      parStr := upper(paramStr(i));
      if parStr ='/V' then
        begin
        verbose := true;
        CheckBoxVerbose.Checked := true;
        end
      else if parStr='/D' then
        begin
        debug := true;
        CheckBoxDebug.Checked := true;
        end
      else if parStr='/HTML' then
        begin
        GenHtml := true;
        CheckBoxHTML.Checked := true;
        end
      else if parStr='/ND' then
        begin
        BatchMode := true;
        CheckBoxBatchMode.Checked := true;
        end
      else if copy(parStr, 1, 3)='/RS' then
        begin
        if copy(parStr, 1, 4)='/RSP' then
          begin
          RuleStrings := true;
          RuleStrFilename := '';
          RuleStringPlace := rs_Parser;
          CheckBoxRuleStrings.Checked := true;
          RadioButtonRulestringParser.Checked := true;
          EditRuleStrFilename.Text := RuleStrFilename;
          end
        else if copy(parStr, 1, 6)='/RSR=' then
          begin
          RuleStrings := GetIntStr( copy( parStr, 5, 255 ),
                                    RuleStrBaseCount, RuleStrFilename );
          RuleStringPlace := rs_RC;
          CheckBoxRuleStrings.Checked := RuleStrings;
          RadioButtonRulestringRC.Checked := true;
          EditRuleStrFilename.Text := RuleStrFilename;
          end
        else if copy(parStr, 1, 5)='/RST=' then
          begin
          RuleStrings := true;
          RuleStrFilename := copy(paramStr(i), 5, 255);
          RuleStringPlace := rs_Text;
          CheckBoxRuleStrings.Checked := true;
          RadioButtonRulestringTextfile.Checked := true;
          EditRuleStrFilename.Text := RuleStrFilename;
          end;
        end
      else if copy(parStr, 1, 2)='/T' then
        begin
        if parStr='/TE' then
          begin
          TableType := ttExtern;
          RadioButtonExternTable.Checked := true;
          RadioButtonExternTableClick( self );
          end
        else if copy(parStr, 1, 3)='/TR' then
          begin
          TableType := ttResource;
          ResTablePrefix := copy(paramStr(i), 4, 255);
          EditPrefix.Text := ResTablePrefix;
          RadioButtonResourceTable.Checked := true;
          RadioButtonResourceTableClick( self );
          end
        else
          begin
          write_usage;
          InvalidOptionError;
          end;
        end
      else if copy(parStr, 1, 2)='/S' then
        begin
        if parStr='/SS' then
          begin
          StackType := stStatic;
          RadioButtonStaticStack.Checked := true;
          RadioButtonStaticStackClick(Self);
          end
        else if copy(parStr, 1, 3)='/SD' then
          begin
          StackType := stDynamic;
          RadioButtonDynamicStack.Checked := true;
          RadioButtonDynamicStackClick(Self);
          end
        else
          begin
          write_usage;
          InvalidOptionError;
          end;
        end
      else if copy(parStr, 1, 2)='/C' then
        begin
        codfilename := copy(paramStr(i), 3, 255);
        EditCodFileName.Text := codfilename;
        CheckBoxCodFile.Checked := true;
        end
      else if copy(parStr, 1, length('/HEAPTRACE') )='/HEAPTRACE' then
        begin
        {necessary for Heapchecking}
        end
      else
        begin
        write_usage;
        InvalidOptionError;
        end;
      end
    else if yfilename='' then
      begin
      yfilename := addExt(upper(paramStr(i)), 'Y');
      end
    else if pasfilename='' then
      pasfilename := addExt(upper(paramStr(i)), 'PAS'){User could want another ext, e.g. *.pp}
    else
      begin
      InvalidOptionError;
      end;

  if yfilename='' then
    begin
    write_usage;
    GetFileNames;
    end
  else
    begin
    BtnBottomDlg.OKBtn.Enabled := true;
    ActiveControl := OKBtn;
    BtnBottomDlg.EditFileName.Text := yfilename;
    end;

  if pasfilename='' then
    pasfilename := ChangeFileExt( yfilename, '.PAS' );
  if not GenHtml then
    lstfilename := ChangeFileExt( yfilename, '.LST' )
  else
    lstfilename := ChangeFileExt( yfilename, '.HTM' );

  if RuleStrings and ( RuleStrFilename = '' ) then
    RuleStrFilename := ChangeFileExt( pasfilename, '.RUL' );

  SearchCodFileName;

  Application.ProcessMessages;

  if BatchMode then
    begin
    OKBtnClick( self );
    CancelBtnClick( Self );
    end;
end;

const Run_once : byte = 0;
{the dos-Version of TPYacc didn't deallocate its tables; so here their contents
  would lead to wrong results, if OKBtnClick executed again.
 Yes, I did try to dealloc that mem in YaccType! }

procedure TBtnBottomDlg.FileBtnClick(Sender: TObject);
begin
  if Run_once = 0 then
    GetFileNames;
end;

procedure TBtnBottomDlg.OKBtnClick(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    Run_once := 1;
    BtnBottomDlg.Caption := 'DYacc processing ' + yfilename;
    {Perform various checks}
    if yfilename = '' then
      fatal( no_filename + ' for *.y-file' );
    if pasfilename = '' then
      fatal( no_filename + ' for *.pas-file' );
    if lstfilename = '' then
      fatal( no_filename + ' for *.lst-file' );
    if codfilename = '' then
      fatal( no_filename + ' for *.cod-file' );
    if not FileExists( yfilename ) then
      fatal( file_not_exist + ' : ' + yfilename );
    if not FileExists( codfilename ) then
      fatal( file_not_exist + ' : ' + codfilename );

    {just do it}
    Yacc.Perform;
    Run_once := 2;
    if BatchMode then
      CancelBtnClick(Sender)
    else
      begin
      OKBtn.Enabled := false;
      BitBtnFile.Enabled := false;
      BitBtnCodeFile.Enabled := false;
      CancelBtn.Caption := '&Close';
{      CancelBtn.Glyph.Free;}
      CancelBtn.Glyph := nil;
      Application.ProcessMessages;
      Repaint;
      end;
    end;
end;

procedure TBtnBottomDlg.CheckBoxVerboseClick(Sender: TObject);
begin
  if Run_once = 0 then
    Verbose := CheckBoxVerbose.Checked;
end;

procedure TBtnBottomDlg.CheckBoxDebugClick(Sender: TObject);
begin
  if Run_once = 0 then
    Debug := CheckBoxDebug.Checked;
end;

procedure TBtnBottomDlg.RadioButtonNormalTableClick(Sender: TObject);
begin
  if Run_once = 0 then
    if RadioButtonNormalTable.Checked then
      begin
      TableType := ttNormal;
      LabelPrefix.Enabled := false;
      EditPrefix.Enabled := false;
      ResTablePrefix := '';
      RadioButtonExternTable.Checked := false;
      RadioButtonResourceTable.Checked := false;
      end;
end;

procedure TBtnBottomDlg.RadioButtonExternTableClick(Sender: TObject);
begin
  if Run_once = 0 then
    if RadioButtonExternTable.Checked then
      begin
      TableType := ttExtern;
      LabelPrefix.Enabled := false;
      EditPrefix.Enabled := false;
      ResTablePrefix := '';
      RadioButtonNormalTable.Checked := false;
      RadioButtonResourceTable.Checked := false;
      end;
end;

procedure TBtnBottomDlg.RadioButtonResourceTableClick(Sender: TObject);
begin
  if Run_once = 0 then
    if RadioButtonResourceTable.Checked then
      begin
      TableType := ttResource;
      LabelPrefix.Enabled := true;
      EditPrefix.Enabled := true;
      ResTablePrefix := EditPrefix.Text;
      RadioButtonNormalTable.Checked := false;
      RadioButtonExternTable.Checked := false;
      end;
end;

procedure TBtnBottomDlg.EditPrefixChange(Sender: TObject);
begin
  if Run_once = 0 then
    ResTablePrefix := Text;
end;

procedure TBtnBottomDlg.CheckBoxBatchModeClick(Sender: TObject);
begin
  if Run_once = 0 then
    BatchMode := CheckBoxBatchMode.Checked;
end;

procedure TBtnBottomDlg.CheckBoxHTMLClick(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    GenHtml := CheckBoxHTML.Checked;
    if not GenHtml then
      lstfilename := ChangeFileExt( yfilename, '.LST' )
    else
      lstfilename := ChangeFileExt( yfilename, '.HTM' );
    end;
end;

procedure TBtnBottomDlg.RadioButtonStaticStackClick(Sender: TObject);
begin
  if Run_once = 0 then
    if RadioButtonStaticStack.Checked then
      begin
      StackType := stStatic;
      RadioButtonDynamicStack.Checked := false;
      end;
end;

procedure TBtnBottomDlg.RadioButtonDynamicStackClick(Sender: TObject);
begin
  if Run_once = 0 then
    if RadioButtonDynamicStack.Checked then
      begin
      StackType := stDynamic;
      RadioButtonStaticStack.Checked := false;
      end;
end;

procedure TBtnBottomDlg.OnExcept(Sender: TObject; E: Exception);
begin
  try
    GiveOutLine( omBoth, 'An Exception Occurred !' );
    GiveOutLine( omBoth, E.ClassName );
    GiveOutLine( omBoth, E.Message );
  finally
    Run_once := 2;
    OKBtn.Enabled := false;
    CancelBtn.Caption := '&Close';
{    CancelBtn.Glyph.Free;}
    CancelBtn.Glyph := nil;
    Application.ProcessMessages;
  end;
end;

procedure TBtnBottomDlg.FormCreate(Sender: TObject);
begin
  Application.OnException := OnExcept;
  Execute( self );
end;

procedure TBtnBottomDlg.CancelBtnClick(Sender: TObject);
begin
  if Run_once <> 1 then
    if Run_once <> 3 then
      begin
      Run_Once := 3;
{$ifdef LargeObjTables}
      YaccTypes.DeallocateTables;
{$endif}
      Close;
      Application.Terminate;
      end;
end;

procedure TBtnBottomDlg.CheckBoxCodFileClick(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    EditCodFileName.Enabled := CheckBoxCodFile.Checked;
    if CheckBoxCodFile.Checked then
      codfilename := EditCodFileName.Text
    else
      codfilename := CODFILENAMEDEFAULT;
    end;
end;

procedure TBtnBottomDlg.BitBtnCodeFileClick(Sender: TObject);
begin
  if Run_once = 0 then
    with OpenDialog1 do
      begin
      Filter := 'Code Template files (*.COD)|*.COD|All files|*.*';
      if Execute then
        begin
        codfilename := FileName;
        EditCodFileName.Text := codfilename;
        CheckBoxCodFile.Checked := true;
        end;
      end;
end;

procedure TBtnBottomDlg.EditFilenameChange(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    yfilename := EditFileName.Text;
    OKBtn.Enabled := true;
    pasfilename := ChangeFileExt(yfilename, '.PAS');
    if not GenHtml then
      lstfilename := ChangeFileExt( yfilename, '.LST' )
    else
      lstfilename := ChangeFileExt( yfilename, '.HTM' );
    end;
    RuleStrFilename := ChangeFileExt(yfilename, '.RUL');
end;

procedure TBtnBottomDlg.EditCodFileNameChange(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    codfilename := EditCodFileName.Text;
    SearchCodFileName;
    end;
end;

procedure TBtnBottomDlg.HelpBtnClick(Sender: TObject);
begin
  if Run_once = 0 then
    GiveOutLine( omScreen, 'Damned, I knew I''ve forgotten something!' )
  else
    GiveOutLine( omScreen, 'Click on Abort' );
end;

procedure TBtnBottomDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if Run_once = 1 then {at work}
    Action := caNone
  else {done work or not at work}
    Action := caFree;
end;

procedure TBtnBottomDlg.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if Run_once = 1 then {at work}
    CanClose := false
  else {done work or not at work}
    CanClose := true;
end;

procedure TBtnBottomDlg.CheckBoxRuleStringsClick(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    RuleStrings := CheckBoxRuleStrings.Checked;
    EditRuleStrFilename.Enabled := RuleStrings;
    EditRuleStrFilename.Text := RuleStrFilename;
    RadioButtonRulestringParser.Enabled := RuleStrings;
    RadioButtonRulestringRC.Enabled := RuleStrings;
    RadioButtonRulestringTextfile.Enabled := RuleStrings;
    RadioButtonRulestringTextfile.Checked := true;
    end;
end;

procedure TBtnBottomDlg.EditRuleStrFilenameChange(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    RuleStrFilename := EditRuleStrFilename.Text;
    end;
end;

procedure TBtnBottomDlg.BitBtnRuleStrFileClick(Sender: TObject);
begin
  if Run_once = 0 then
    with OpenDialog1 do
      begin
      Filter := 'Resource Script (*.RC)|*.RC|All files|*.*';
      if Execute then
        begin
        RuleStrFilename := FileName;
        EditRuleStrFilename.Text := FileName;
        CheckBoxRuleStrings.Checked := true;
        RadioButtonRulestringTextfile.Checked := true;
        end;
      end;
end;

procedure TBtnBottomDlg.RadioButtonRulestringRCClick(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    SpinEditRulestringRCBaseCount.Enabled := RadioButtonRulestringRC.Checked;
    RuleStringPlace := rs_RC;
    RadioButtonRulestringTextFile.Checked := false;
    RadioButtonRulestringParser.Checked := false;
    if RuleStrings and
       ( ( RuleStrFilename = '' ) or ( ExtractFileExt( RuleStrFilename ) = '.RUL' ) ) then
      RuleStrFilename := ChangeFileExt( pasfilename, '.RC' );
    EditRuleStrFilename.Enabled := true;
    EditRuleStrFilename.Text := RuleStrFilename;
    end;
end;

procedure TBtnBottomDlg.RadioButtonRulestringTextfileClick(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    RuleStringPlace := rs_Text;
    RadioButtonRulestringRC.Checked := false;
    RadioButtonRulestringParser.Checked := false;
    SpinEditRulestringRCBaseCount.Enabled := false;
    if RuleStrings and
       ( ( RuleStrFilename = '' ) or ( ExtractFileExt( RuleStrFilename ) = '.RC' ) ) then
      RuleStrFilename := ChangeFileExt( pasfilename, '.RUL' );
    EditRuleStrFilename.Enabled := true;
    EditRuleStrFilename.Text := RuleStrFilename;
    end;
end;

procedure TBtnBottomDlg.RadioButtonRulestringParserClick(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    RuleStringPlace := rs_Parser;
    RadioButtonRulestringRC.Checked := false;
    RadioButtonRulestringTextfile.Checked := false;
    SpinEditRulestringRCBaseCount.Enabled := false;
    EditRuleStrFilename.Text := '';
    EditRuleStrFilename.Enabled := false;
    end;
end;

procedure TBtnBottomDlg.SpinEditRulestringRCBaseCountChange(Sender: TObject);
begin
  if Run_once = 0 then
    begin
    RuleStrBaseCount := SpinEditRulestringRCBaseCount.Value;
    end;
end;

initialization
end(*YaccDlg*).

