
const

no_of_keywords = 123;
keyword_size = 14;

keyword_identifier_table : array [ 1..no_of_keywords ] of String[ keyword_size ] = (
  '(', ')', '*', '**', '+', ',', '-', '.', '..', '/', ':', ':=', ';', '<', '<=', 
  '<>', '<Integer>', '<PString>', '<Real>', '=', '>', '>=', '@', 'ABSOLUTE', 
  'ABSTRACT', 'AND', 'ARRAY', 'AS', 'ASM', 'ASSEMBLER', 'AT', 'AUTOMATED', 
  'BEGIN', 'CASE', 'CDECL', 'CLASS', 'CONST', 'CONSTRUCTOR', 'Char', 'DEFAULT', 
  'DESTRUCTOR', 'DISPID', 'DIV', 'DO', 'DOWNTO', 'DYNAMIC', 'ELSE', 'END', 
  'EXCEPT', 'EXPORT', 'EXPORTS', 'EXTERNAL', 'FAR', 'FILE', 'FINALIZATION', 
  'FINALLY', 'FOR', 'FORWARD', 'FUNCTION', 'GOTO', 'IF', 'IMPLEMENTATION', 'IN', 
  'INDEX', 'INHERITED', 'INITIALIZATION', 'INLINE', 'INTERFACE', 'INTERRUPT', 
  'IS', 'Identifier', 'LABEL', 'LIBRARY', 'MESSAGE', 'MOD', 'NAME', 'NEAR', 
  'NIL', 'NODEFAULT', 'NOT', 'OBJECT', 'OF', 'ON', 'OR', 'OVERRIDE', 'PACKED', 
  'PASCAL', 'PRIVATE', 'PROCEDURE', 'PROGRAM', 'PROPERTY', 'PROTECTED', 'PUBLIC', 
  'PUBLISHED', 'RAISE', 'READ', 'RECORD', 'REGISTER', 'REPEAT', 'RESIDENT', 
  'SET', 'SHL', 'SHR', 'STDCALL', 'STORED', 'STRING', 'THEN', 'THREADVAR', 'TO', 
  'TRY', 'TYPE', 'UNIT', 'UNTIL', 'USES', 'VAR', 'VIRTUAL', 'WHILE', 'WITH', 
  'WRITE', 'XOR', '[', ']', '^'
);

keyword_token_table : array [ 1..no_of_keywords ] of Integer = (
  LPAREN, RPAREN, STAR, STARSTAR, PLUS, COMMA, MINUS, DOT, DOTDOT, SLASH, 
  COLON, _ASSIGNMENT_, SEMICOLON, LT, LE, NOTEQUAL, UNSIGNED_INTEGER, 
  STRING_CONST, UNSIGNED_REAL, EQUAL, GT, GE , APE_SYMBOL, _ABSOLUTE_, 
  _ABSTRACT_, _AND_, _ARRAY_, _AS_, _ASM_, 
  _ASSEMBLER_, _AT_, _AUTOMATED_, _BEGIN_, 
  _CASE_, _CDECL_, _CLASS_, _CONST_, 
  _CONSTRUCTOR_, IMMCHAR_ID, _DEFAULT_, _DESTRUCTOR_, 
  _DISPID_, _DIV_, _DO_, _DOWNTO_, 
  _DYNAMIC_, _ELSE_, _END_, _EXCEPT_, 
  _EXPORT_, _EXPORTS_, _EXTERNAL_, _FAR_, 
  _FILE_, _FINALIZATION_, _FINALLY_, _FOR_, 
  _FORWARD_, _FUNCTION_, _GOTO_, _IF_, 
  _IMPLEMENTATION_, _IN_, _INDEX_, _INHERITED_, 
  _INITIALIZATION_, _INLINE_, _INTERFACE_, 
  _INTERRUPT_, _IS_, IDENTIFIER, _LABEL_, 
  _LIBRARY_, _MESSAGE_, _MOD_, _NAME_, 
  _NEAR_, _NIL_, _NODEFAULT_, _NOT_, 
  _OBJECT_, _OF_, _ON_, _OR_, _OVERRIDE_, 
  _PACKED_, _PASCAL_, _PRIVATE_, _PROCEDURE_, 
  _PROGRAM_, _PROPERTY_, _PROTECTED_, _PUBLIC_, 
  _PUBLISHED_, _RAISE_, _READ_, _RECORD_, 
  _REGISTER_, _REPEAT_, _RESIDENT_, _SET_, 
  _SHL_, _SHR_, _STDCALL_, _STORED_, 
  _STRING_, _THEN_, _THREADVAR_, _TO_, 
  _TRY_, _TYPE_, _UNIT_, _UNTIL_, _USES_, 
  _VAR_, _VIRTUAL_, _WHILE_, _WITH_, 
  _WRITE_, _XOR_, LBRAC, RBRAC, UPARROW
);

(* KWTBL keyword table lookup procedure for errorhandling V1.0 *)
{ $Id: all_ids.inc,v 1.1 1998/05/04 17:42:04 rob Exp rob $}

function kwIDlookup(var kw : String; code : Integer ) : Boolean;
  (* checks whether code is in the keyword table; if so, returns the
     corresponding string *)
var i : integer;
begin
  for i := 1 to no_of_keywords do
    if keyword_token_table[i] = code then begin
      kwIDlookup := true;
      kw := keyword_identifier_table[i];
      exit;
    end;
  kwIDlookup := false
end(*kwlookup*);

