
/* Sample for DYacc, Robert Zierer */

%{(* $Id: Parser.y,v 1.1 1998/05/04 17:42:04 rob Exp rob $*)
(*
 *
 *)
{$D+,L+,Y+}
unit Parser;{$B-}

interface
uses LexLib, YaccLib;

procedure Run_Parse;

%}

%start compilation_file

/* Lexical stuff: */

/*  ***  F O R   P A S C A L  ***  */

%token  ILLEGAL

/* Note the Pascal keyword tokens are stropped with leading underscore
   (e.g. _AND) in the Turbo Pascal Yacc version, because these identifiers
   will be declared as token numbers in the output file generated by Yacc,
   and hence must not collide with Turbo Pascal keywords. */

/* Pascal 'reserved words' */

%token   _AND_  _AS_  _ASM_  _ARRAY_
%token   _BEGIN_  _CASE_  _CLASS_  _CONST_
%token   _CONSTRUCTOR_  _DESTRUCTOR_  _DIV_  _DO_
%token   _DOWNTO_  _ELSE_  _END_  _EXCEPT_
%token   _EXPORTS_  _FILE_  _FINALIZATION_  _FINALLY_
%token   _FOR_  _FUNCTION_  _GOTO_  _IF_
%token   _IMPLEMENTATION_  _IN_  _INHERITED_  _INLINE_
%token   _INITIALIZATION_  _INTERFACE_  _IS_  _LABEL_
%token   _LIBRARY_  _MOD_  _NIL_  _NOT_
%token   _OBJECT_  _OF_  _ON_  _OR_
%token   _PACKED_  _PROCEDURE_  _PROGRAM_  _PROPERTY_
%token   _RAISE_  _RECORD_  _REPEAT_  _SET_
%token   _SHL_  _SHR_  _STRING_  _THEN_
%token   _THREADVAR_  _TO_  _TRY_  _TYPE_
%token   _UNIT_  _UNTIL_  _USES_  _VAR_
%token   _WHILE_  _WITH_  _XOR_

/* Pascal 'Standard-Directives' */

%token   _ABSOLUTE_  _ABSTRACT_  _ASSEMBLER_  _AT_
%token   _AUTOMATED_  _CDECL_  _DEFAULT_  _DISPID_
%token   _DYNAMIC_  _EXPORT_  _EXTERNAL_  _FAR_
%token   _FORWARD_  _INDEX_  _INTERRUPT_  _MESSAGE_
%token   _NAME_  _NEAR_  _NODEFAULT_  _OVERRIDE_
%token   _PASCAL_  _PRIVATE_  _PROTECTED_  _PUBLIC_
%token   _PUBLISHED_  _READ_  _REGISTER_  _RESIDENT_
%token   _STDCALL_  _STORED_  _VIRTUAL_  _WRITE_

/* Pascal 'Miscellaneous' */

%token   _ASSIGNMENT_  DOTDOT  GE  LE
%token   NOTEQUAL  STARSTAR  IDENTIFIER  IMMCHAR_ID
%token   COLON  COMMA  DOT  EQUAL
%token   GT  LBRAC  LPAREN  LT
%token   MINUS  PLUS  RBRAC  RPAREN
%token   SEMICOLON  SLASH  STAR  UPARROW
%token   APE_SYMBOL

/* Pascal 'System-Routines' */
/* right EQUAL  NOTEQUAL  LT  GT  LE  GE  _IN_    */
/* right PLUS  MINUS  _OR_  _XOR_   */
/* right STAR  SLASH  _DIV_  _MOD_  _SHL_  _SHR_  _AND_  */
/* right UMINUS  APE_SYMBOL _NOT_     */

%right _THEN_ _ELSE_            /* resolve dangling else */

%token  <Longint> UNSIGNED_INTEGER
%token  <Extended> UNSIGNED_REAL
%token  <PString> STRING_CONST

%%

/* Rules: general */


%%

procedure Run_Parse;
begin
  filename := paramStr(1);
  if filename='' then
    begin
      write('input file: ');
      readln(filename);
    end;
  assign(yyinput, filename);
  reset(yyinput);

  if yyparse=0 then writeln('successful parse!');
  writeln('Lines:', yylineno);

  Flush(yyoutput);

end;

begin
end.
